/*
 * %Copyright%
 */

#include <RTPriv/RTstdio.h>
#include <RTPriv/RTstdlib.h>
#include <RTPubl/Control.h>
#include <RTPubl/Main.h>
#include <RTPubl/MemUtil.h>

#define RTS_MEMORY_ANALYSIS 1

#if RTS_MEMORY_ANALYSIS
int allocCount = 0;
#endif

void * RTMemoryUtil_new( int size )
{
#if RTS_MEMORY_POLICY != RTS_CAN_ALLOCATE
    if( RTMain_soleInstance()->state == RTMain_executing )
    {
#if RTS_MEMORY_POLICY == RTS_NEVER_ALLOCATE
	RTController_setError(  RTMain_controller(),
				RTController_unauthorizedMemoryAllocation,
				RTController_SystemService,
				0, 0 );
#if STDIO_ENABLED
	RTStdio_panic( "Memory allocation while running!!!" );
#endif
#else
#if STDIO_ENABLED
	RTStdio_putString( "Memory allocation while running!!!" );
#endif
#endif /* RTS_MEMORY_POLICY == RTS_NEVER_ALLOCATE */
    }
#endif /* RTS_MEMORY_POLICY != RTS_CAN_ALLOCATE */

#if RTS_MEMORY_ANALYSIS
    allocCount += size;
// MH: To print the allocated memory (only allocs during startup)
    printf("Alloc: %d, %d\n", size, allocCount);
#endif

    return (void *)malloc( (unsigned int)size );
}

